-- 社团狩猎结算界面
checkRequire("Lua_FightingResultBaseWindow");
checkRequire("Lua_FightResultRewardsItem");
Lua_FactionHuntingCopyResultWindow= class("Lua_FactionHuntingCopyResultWindow", Lua_FightingResultBaseWindow);
function Lua_FactionHuntingCopyResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FactionHuntingCopyResultWindow";

	self.winTitleAtlas = "ui_zhujiemian_z_tzcg";
	self.failTitleAtlas = "ui_zhujiemian_z_tzsb";
	self.bShowStar = false;
end

function Lua_FactionHuntingCopyResultWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.tipsBg:setLocation(-4, 129);
	local starTime = DataCenter.factionHuntingUtil.huntStarTime;
	local maxTime = tonumber(starTime[4]); -- 最大时长
	local starOne = tonumber(maxTime -  starTime[1]); -- 一档剩余时间 250
	local starTow = tonumber(starOne - (starTime[2] - starTime[1])); -- 二档剩余时间  225
	local starThree = tonumber(starTow - (starTime[3] - starTime[2])); -- 三档剩余时间 150 
	local starfour = tonumber(starThree - (starTime[4] - starTime[3])); -- 四档剩余时间

	local resultList = DataCenter.factionHuntingData:resultList();
	local leftTime = tonumber(resultList.leftTime - 1);
	local starNum = 0;
	if  leftTime >= starOne then 
		starNum = 3;
	elseif starTow <= leftTime and  leftTime< starOne then 
		starNum = 2
 	elseif  starThree <= leftTime and  leftTime < starTow then
 		starNum = 1
	elseif starfour < leftTime and  leftTime < starThree then
		starNum = 0
	end
	
	local curBossVo = DataCenter.factionHuntingUtil:getHuntBossInfo();
	local boss_name = curBossVo == nil and "" or getConfig({"monster", curBossVo.huntBossId, "name"});
	if resultList.state == 1 then
		local nameLab = UICreate.createLabel(self.content, "", 9.5, 146, 300, 30, 30);
		nameLab.pivot =  UIWidget.Pivot.Center;
		nameLab.overflowMethod = UILabel.Overflow.ResizeFreely;
		nameLab:setDepth(5);

		local luckLab = UICreate.createLabel(self.content, "", -393, 70.5, 160, 32, 32);
		luckLab.pivot =  UIWidget.Pivot.Left;
		luckLab.overflowMethod = UILabel.Overflow.ResizeFreely;
		luckLab:setDepth(5);
		
		local killLab = UICreate.createLabel(self.content, "", 34, 70.5, 160, 32, 32);
		killLab.pivot =  UIWidget.Pivot.Left;
		killLab.overflowMethod = UILabel.Overflow.ResizeFreely;
		killLab:setDepth(5);

		local harmLab = UICreate.createLabel(self.content,"",-393,20,160,23,32);
		harmLab.pivot =  UIWidget.Pivot.Left;
		harmLab.overflowMethod = UILabel.Overflow.ResizeFreely;
		harmLab:setDepth(5);

		local rankLab = UICreate.createLabel(self.content, "", 34, 20, 160, 32, 32);
		rankLab.pivot =  UIWidget.Pivot.Left;
		rankLab.overflowMethod = UILabel.Overflow.ResizeFreely;
		rankLab:setDepth(5);

		nameLab.text = LanUtil.formateStr(LanUtil.getValue(123719),tostring(boss_name));
		luckLab.text = LanUtil.formateStr(LanUtil.getValue(123720),tostring(resultList.luckyPlayer)); -- 幸运玩家
		killLab.text = LanUtil.formateStr(LanUtil.getValue(123721),tostring(resultList.lastPlayer)); -- 最后一击玩家
		harmLab.text = LanUtil.formateStr(LanUtil.getValue(123722),string.format("%0.2f",tostring(resultList.harm / 100)).."%"); -- 自己总伤害比例
		rankLab.text = LanUtil.formateStr(LanUtil.getValue(123723),tostring(resultList.rank)); -- 排名

		if resultList.pick_up ~= nil and #resultList.pick_up > 0 then
			local rewardArr = Array();
			local tvo;
			for i = 1, #resultList.pick_up do 
				tvo = Lua_ToolVo.createToolVo(resultList.pick_up[i].id);
				tvo:fromServer(resultList.pick_up[i]);
				rewardArr:add(tvo);
			end

			if self.rankReward == nil then
				self.rankReward = Lua_FightResultRewardsItem.new(self.content, nil, 4, -76, false, 544);
				self.rankReward:setLocation(0, 36, 0);
			end
			self.rankReward:setShowRewardArr(rewardArr); -- 获得的奖励ID
		end
		self:setShowInfo(1,DataCenter.factionHuntingUtil.huntCloseTime, starNum);
	else
		local name = UICreate.createLabel(self.content, "", 9.5, 146, 300, 30, 30);
		self.tipsBg:setGray(true);
		name.pivot =  UIWidget.Pivot.Center;
		name.overflowMethod = UILabel.Overflow.ResizeFreely;
		name:setDepth(5);
		
		name.text = LanUtil.formateStr(LanUtil.getValue(123724), tostring(boss_name));
		self:setShowInfo(-1,DataCenter.factionHuntingUtil.huntCloseTime,starNum);
	end
end

function Lua_FactionHuntingCopyResultWindow:onBackBtnClick(go)
	DataCenter.hook:stop(true);
	self:superCall("onBackBtnClick", go);
end

function Lua_FactionHuntingCopyResultWindow:dispose()
	if self.rankReward ~= nil then
		self.rankReward:dispose();
		self.rankReward = nil;
	end
	DataCenter.factionHuntingData.result_list = nil;
	DataCenter.godWarData:sCloseSceneMsg();

	self:superCall("dispose");
end