-- 社团狩猎左侧信息栏界面
checkRequire("Lua_LeftInfoBaseWindow");
checkRequire("Lua_FactionHuntingStarItem");
Lua_FactionHuntingLeftWindow  = class("Lua_FactionHuntingLeftWindow", Lua_LeftInfoBaseWindow);
function Lua_FactionHuntingLeftWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FactionHuntingLeftWindow";
	self.skinName = "FactionHuntingLeftPanel_skin";
	self.maxValue = 100;
end

function Lua_FactionHuntingLeftWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.boss_name = "";
	local curBossVo = DataCenter.factionHuntingUtil:getHuntBossInfo();
	if curBossVo ~= nil then
		self.boss_name = getConfig({"monster", curBossVo.huntBossId, "name"}); -- 怪物名字
	end
	self.showLab.text = LanUtil.getValue(123716);
	self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(123711), tostring(self.boss_name));

	self.titleBg.clickScale = false;
	self.bg.clickScale = false;
	self.rankBtn.clickScale = false;
	self.titleBg:addClickFuntion(self, self.onBgClick);
	self.bg:addClickFuntion(self, self.onBgClick);
	self.rankBtn:addClickFuntion(self, self.onOpenRankClick);

	self.starItem = Lua_FactionHuntingStarItem.new(self.content);

	--self:showFactionHuntingSceneInfo();
	self:addLuaEvent("SHOW_FACTIONHUNTINGSCENEINFO", self, self.showFactionHuntingSceneInfo);
	self:addLuaEvent("MENU_OUT_CLICK", self, self.onMenuOutClick);

	Lua_CommonUtil.addTimer("updateHuntingCombatLeftTime", 1, self, self.updateHuntingCombatLeftTime);
end

function Lua_FactionHuntingLeftWindow:setShowState(val)
	self:superCall("setShowState", val);

	if val then
		self.rankBtn:setLocation(295, 139, 0);
	else
		self.rankBtn:setLocation(245, 139, 0);
	end
end

function Lua_FactionHuntingLeftWindow:showFactionHuntingSceneInfo()
	-- local huntBossId = DataCenter.factionHuntingUtil.huntBossId; -- 狩猎BossID
	-- local curCfg = getConfig({"monster",huntBossId});
	-- local boss_name = curCfg.name;--怪物名字
	local combat_list = DataCenter.factionHuntingData:combatList();
	local cur = combat_list.cur; -- 当前boss数
	local total = combat_list.total; -- 总boss数
	self.skillNmuLab.text = LanUtil.formateStr(LanUtil.getValue(123709), tostring(self.boss_name), tostring(cur), tostring(total));
	
	local percent = combat_list.percent; -- 百分比
	self.progressBar:setMaxValue(self.maxValue);
	self.progressBar:setText(percent.."%");
	self.progressBar:setValue(percent);

	self.leftTime = combat_list.leftTime;
end

function Lua_FactionHuntingLeftWindow:onMenuOutClick(o)
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(121635), type = 1, subFun = self.onOutClick});
end

function Lua_FactionHuntingLeftWindow:onOutClick(val)
	-- DataCenter.godWarData:sCloseSceneMsg();
	-- Lua_WindowUtil.openWin("Lua_FactionHuntingLeftWindow", WinParam.ACTION_CLOSE);
	DataCenter.hook:stop(true);
	-- 2018.05.14 服务端处理退出还是结算
	sendMsg(10400853);
end

function Lua_FactionHuntingLeftWindow:updateHuntingCombatLeftTime()
	self.leftTime = self.leftTime - 1;
	if self.leftTime > 0 then
		self.endTimeLab.text = LanUtil.formateStr(LanUtil.getValue(123710), TimeTransform.getInstance():transSeconds1(self.leftTime, true));
	else
		self.endTimeLab.text = LanUtil.formateStr(LanUtil.getValue(123710), tostring(0)).."[00E125]"..LanUtil.getValue(26);
		--Lua_CommonUtil.removeTimer(self,self.updateCombatLeftTime);
	end
end

function Lua_FactionHuntingLeftWindow:onBgClick(go)
end

function Lua_FactionHuntingLeftWindow:onOpenRankClick()
	Lua_WindowUtil.openWin("Lua_FactionHuntingRankWindow", WinParam.ACTION_AUTO);
end

function Lua_FactionHuntingLeftWindow:dispose()
	if self.starItem ~= nil then
		self.starItem:dispose();
		self.starItem = nil;
	end
	TweenUtil.getInstance():stop(self.content);
	Lua_CommonUtil.removeTimer(self,self.updateHuntingCombatLeftTime);

	self:superCall("dispose");
end