-- 社团狩猎排行
Lua_FactionHuntingRankWindow  = class("Lua_FactionHuntingRankWindow",Lua_ThirdSizeWindow);
function Lua_FactionHuntingRankWindow:ctor()
	self:superCall("ctor",false,3500,true,"傷害排行");
	self.w = 600;
	self.h = 564;
	self.windowName = "Lua_FactionHuntingRankWindow";
	self.skinName = "FactionHuntingRankPlan_skin";
	self.isClickClose = false;
	self.isModel = true;
end

function Lua_FactionHuntingRankWindow:dispose()	
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_FactionHuntingRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(-5, 216, 593, 370));
	self.dragList:setLocation(4, -225, 0);
	self.dragList:setListCell(FactionHuntingRankCellItem, 88, 593, 1);
	self.dragList.canDrag = true;--设置按钮为可拖动
    self.dragList.content.gameObject.name = "FactionHuntingRank_DragList";
	self.dragList.sub.gameObject.name = "Grid";
	
    DataCenter.factionHuntingData:sOpenFactionHuntingRankMsg();
	self:addLuaEvent("SHOW_FACTIONHUNTINGRANKINFO", self, self.showFactionHuntingRankInfo);
end

function Lua_FactionHuntingRankWindow:showFactionHuntingRankInfo()
	local rankArr = DataCenter.factionHuntingData:rankArr();
	local rankList = DataCenter.factionHuntingData:rankList();

	if rankList.rank == 0 then
		self.playerRankTxt.text = LanUtil.getValue(123718);
	else
		self.playerRankTxt.text = rankList.rank;
	end
	self.playerNameTxt.text = rankList.name;
	self.playerLvlTxt.text = rankList.lvl;
	self.playerHarmTxt.text = string.format("%0.2f",tostring(rankList.harm/100)).."%";

    self.dragList:setLuaArrayData(rankArr, true);
end








FactionHuntingRankCellItem = class("FactionHuntingRankCellItem", Lua_ListCell);
function FactionHuntingRankCellItem:ctor(p)
	self:superCall("ctor", p,"FactionHuntingRankItem_skin");
end

function FactionHuntingRankCellItem:buildShowItem()
	self:superCall("buildShowItem");
end
function FactionHuntingRankCellItem:setData(data)
	self.data = data;
	
	self.rankTxt.text = "";
	self.rank:setEnable(true);

	if data.rank == 1 then
		self.rank:setAltas("leaderBoard_atlas", "ui_paihang_widget_no1");
	elseif data.rank == 2 then
		self.rank:setAltas("leaderBoard_atlas", "ui_paihang_widget_no2");
	elseif data.rank == 3 then
		self.rank:setAltas("leaderBoard_atlas", "ui_paihang_widget_no3");
	else
		self.rank:setEnable(false);
		self.rankTxt.text = data.rank;
	end
	self.playerNameTxt.text = data.name;
	self.lvlTxt.text = data.lvl;
	self.harmTxt.text = string.format("%0.2f",tostring(data.harm/100)).."%";
end

function FactionHuntingRankCellItem:dispose()
	self:superCall("dispose");
end