-- 社团狩猎
Lua_FactionHuntingStarItem = class("Lua_FactionHuntingStarItem", Lua_DisplayObject);
function Lua_FactionHuntingStarItem:ctor(p)
	self:superCall("ctor", p, "FactionHuntingStarItem_skin");
	self.starTime = DataCenter.factionHuntingUtil.huntStarTime;
end

function Lua_FactionHuntingStarItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self:addLuaEvent("SHOW_FACTIONHUNTINGSCENEINFO", self, self.updateData);
	Lua_CommonUtil.addTimer("Lua_FactionHuntingStarItem", 0.2, self, self.onCountDown);
end

function Lua_FactionHuntingStarItem:updateData()
	local combat_list = DataCenter.factionHuntingData:combatList();
	self.leftTime = combat_list.leftTime;
end

function Lua_FactionHuntingStarItem:onCountDown()
	if self.leftTime == nil then
		return
	end	
	local lt = tonumber(self.leftTime) - 1;

	if lt <= 0 then
		lt = 0;
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
	end

	local str = TimeTransform.getInstance():transSeconds6(math.floor(lt), false, true);
	local s = 0; -- 星级数量
	local lanNum = 121112;
	local maxTime = self.starTime[4]; -- 最大时长
	local starOne = maxTime -  self.starTime[1]; -- 一档剩余时间 
	local starTow = starOne - (self.starTime[2] - self.starTime[1]); -- 二档剩余时间 
	local starThree = starTow - (self.starTime[3] - self.starTime[2]); -- 三档剩余时间 
	local starfour = starThree - (self.starTime[4] - self.starTime[3]); -- 四档剩余时间 
	if  lt > starOne then 
		lt = lt - starOne;
		s = 2;
		lanNum = 121112;
		str = TimeTransform.getInstance():transSeconds6(math.floor(lt), false, true);
	elseif starTow < lt and lt <= starOne then 
		lt = lt - starTow;
		s = 1;
		lanNum = 121112;
		str = TimeTransform.getInstance():transSeconds6(math.floor(lt), false, true);
	elseif  starThree < lt and lt <= starTow then
		lt = lt - starThree;
		s = 0;
		lanNum = 121112;
		str = TimeTransform.getInstance():transSeconds6(math.floor(lt), false, true);
	elseif starfour < lt and lt <= starThree then
		lt = lt - starfour;
		s = -1;
		lanNum = 121131;
		str = TimeTransform.getInstance():transSeconds6(math.floor(lt), false, true);
	end
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(lanNum), str, tostring(s));
	self:setStarNum(s + 1);
end

function Lua_FactionHuntingStarItem:setStarNum(val)
	for i = 1, 3 do
		-- self["star"..i]:setGray(i > val);
		if i > val then
			self["star"..i]:setAltas("copy_atlas_2", "ui_fuben_nanduxing_s");
		else
			self["star"..i]:setAltas("copy_atlas_2", "ui_fuben_nanduxing");
		end
	end
end

function Lua_FactionHuntingStarItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onCountDown);

	self:superCall("dispose");
end