checkRequire("Lua_FactionLevelVo");
checkRequire("Lua_FactionDefine");
Lua_FactionHuntingWindow = class("Lua_FactionHuntingWindow", Lua_SecondSizeWindow);
function Lua_FactionHuntingWindow:ctor()
	self:superCall("ctor");
	self.isModel = true;
	self.titleText = LanUtil.getValue(123700);

	self.windowName = "Lua_FactionHuntingWindow";
	self.skinName = "FactionHuntingWindow_skin";
end
	
function Lua_FactionHuntingWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.huntingUtil = DataCenter.factionHuntingUtil;
	-- self.huntBossId = self.huntingUtil.huntBossId;--狩猎BossID
	-- self.curCfg = getConfig({"monster",self.huntBossId});
	self.wenhao:addClickFuntion(self,self.onHelp);--问号
	self.payBtn:addClickFuntion(self,self.onButtonPayClick);
	self.startBtn:addClickFuntion(self,self.onShowOpenTips);
	-- -- -- 奖励展示
	-- local rewardId = self.huntingUtil.huntRewardId; 
    self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:buildShowItem();
    self.rItem:setLayout(92, 93, 3);
	self.rItem:setMaxShow(9);
	self.rItem:setDepth(self.depth+10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(1,1);
    self.rItem:setLocation(201.5,14.5, 0);
    -- self.rItem:setRewardByRewardList(Array(rewardId));

	self.infoBg:setLocation(0,-4)
	self.infoBg:SetDimensions(912,656);
	self.winTitleBg:setLocation(0,306)
	self.winTitleBg:SetDimensions(912,78)
	self.titleNameTxt:setLocation(0,306)
	self.btnClose:setLocation(418,306)

    local atlas = self.huntingUtil.huntGoodsInfo.atlas;
    local icon = self.huntingUtil.huntGoods;
	self.lingshi1:setAltas(atlas, icon);
	self.lingshi2:setAltas(atlas, icon);
	self.lingshi3:setAltas(atlas, icon);

	DataCenter.factionHuntingData:sFactionFactionHuntingMsg();
	self:addLuaEvent("SHOW_FACTIONHUNTINGINFO", self, self.showFactionHuntingInfo);   --返回面板信息
end

function Lua_FactionHuntingWindow:showFactionHuntingInfo()
	self.hunting_list = DataCenter.factionHuntingData:huntingList();
	self.openState = self.hunting_list.openState;--开启活动状态
	self.huntGoodsId = self.huntingUtil.huntGoods;--开启狩猎材料ID

	local newTime = tonumber(os.date("%H%M"));
	local minTime = self.huntingUtil.huntTime[1];--开启时间
	local maxTime = self.huntingUtil.huntTime[2];
	local openTimes = self.hunting_list.openTimes; --开启次数
	local huntTimes = self.huntingUtil.huntTimes;--最大次数
	local donateAmount = self.hunting_list.donateAmount;--库存
	local openHuntGoods = self.huntingUtil.openHuntGoods[2];--开启消耗

	-- local boss_name = self.curCfg.name;--怪物名字
	local myFactionInfo = DataCenter.factionData.myFactionInfo;
	self.levelData = Lua_FactionLevelVo.new(myFactionInfo.leagueLvl);--帮派等级vo
	self.huntGoodsNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.huntGoodsId)--身上拥有灵石数量
	--self.classTxt.text = LanUtil.formateStr(LanUtil.getValue(123701), tostring(DataCenter.roleData.worldLevel));--世界等级

	self.curBossVo = self.huntingUtil:getHuntBossInfo(); 
	if self.curBossVo ~= nil then
		self.rItem:setRewardByRewardList(Array(self.curBossVo.rewardId));
		self.monsterName.text = getConfig({"monster", self.curBossVo.huntBossId, "name"});--怪物名字
		self:showModel();
	end

	self.numTxt.text = LanUtil.formateStr(LanUtil.getValue(123702), tostring(openTimes),tostring(huntTimes));--挑战次数
	self.alwaysNumTxt.text = LanUtil.formateStr(LanUtil.getValue(123703), tostring(donateAmount),tostring(self.levelData.maxSell));--帮派存库
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(123704), tostring(self.huntingUtil.showTime));--可挑战时间
	self.ownTxt.text = LanUtil.formateStr(LanUtil.getValue(123706), tostring(self.huntGoodsNum));--身上拥有灵石数量
	self.consumeTxt.text = LanUtil.formateStr(LanUtil.getValue(123707), tostring(openHuntGoods));--开启狩猎消耗
	if self.hunting_list.rights == 1 then--职位判断--权限
		self.startBtn:setBtnEnable(true);
		if self.openState == 0 then--状态判断
			self.startBtn.label = LanUtil.getValue(123713);
			if  minTime <= newTime and newTime <= maxTime and openTimes < huntTimes and donateAmount >= openHuntGoods then --红点显示判断
				self:showRedDot(true);
			else
				self:showRedDot(false);
			end
		else
			self.startBtn.label = LanUtil.getValue(123714);
			self:showRedDot(true);
		end
	else
		if self.openState == 0 then
			self.startBtn:setBtnEnable(false);
			self.startBtn.label = LanUtil.getValue(123713);
			self:showRedDot(false);
		else
			self.startBtn.label = LanUtil.getValue(123714);
			self:showRedDot(true);
			self.startBtn:setBtnEnable(true);
		end	
	end

	if self.huntGoodsNum > 0 then --红点显示
		self:showRedDotTow(true);
	else
		self:showRedDotTow(false);
	end
end

function Lua_FactionHuntingWindow:showModel()--模型显示
	if self.curBossVo ~= nil then 
		local huntBossRotation = self.curBossVo.config.rotation;--模型初始旋转位置
		local huntBossScaling = self.curBossVo.config.scaling;--缩放比例
		local huntBossPosition = self.curBossVo.config.position;--模型初始位置
		local jid = getConfig({"monster", self.curBossVo.huntBossId, "jid"});
		local modelStr="/model/"..tostring(jid);

		if self.monsEffect == nil then 
			self.monsEffect = UICreate.createUIEffect(self.content, modelStr, jid, 0, 0);
			self.monsEffect:setSacle(huntBossScaling[1],huntBossScaling[2],huntBossScaling[3]);
			self.monsEffect:setLocation(huntBossPosition[1], huntBossPosition[2], huntBossPosition[3]);
			self.monsEffect:setRot(huntBossRotation[1], huntBossRotation[2], huntBossRotation[3]);
			self.monsEffect:SetRenderQueue(self.monsterName, 2, 2);
		end
	end
	--self.monsEffect:setUrl(modelStr,self.curCfg.jid)
end

function Lua_FactionHuntingWindow:onButtonPayClick()--缴纳灵石
	if self.hunting_list.donateAmount == self.levelData.maxSell then
		OperateAlert.show(LanUtil.getValue(123729))
	else
		if self.huntGoodsNum > 0 then
			Lua_WindowUtil.openWin("Lua_FactionHuntingPaymentWindow", WinParam.ACTION_AUTO);
		else
			OperateAlert.show(LanUtil.getValue(123728));
		end
	end	
end

function Lua_FactionHuntingWindow:onShowOpenTips()
	if self.openState == 0 then --状态判断
		tipData = {};
	    tipData.des = LanUtil.formateStr(LanUtil.getValue(123730), tostring(self.huntingUtil.openHuntGoods[2]));
	    tipData.owner = self;
	    tipData.type = 1;
	    tipData.subName = LanUtil.getValue(123606);
	    tipData.subFun = self.onButtonGoSenceClick;--确认
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	else
		DataCenter.factionHuntingData:sOpenFactionHuntingSceneMsg();
	end
end

function Lua_FactionHuntingWindow:onButtonGoSenceClick()--开启 进入活动
	local sceneID = self.huntingUtil.huntSenceId;
	local newTime = tonumber(os.date("%H%M"));

	if DataCenter.roleData.sceneId == sceneID then -- 狩猎场景
		OperateAlert.show(LanUtil.getValue(121805));
		return;
	end

	if  self.huntingUtil.huntTime[1] <= newTime and newTime <= self.huntingUtil.huntTime[2] then --时间判断
		if self.hunting_list.openTimes <= self.huntingUtil.huntTimes then--开启次数判断
			if self.hunting_list.donateAmount >= self.huntingUtil.openHuntGoods[2] then--库存判断
				DataCenter.factionHuntingData:sOpenFactionHuntingMsg();
			else
				OperateAlert.show(LanUtil.getValue(123726));
			end
		else
			OperateAlert.show(LanUtil.getValue(123725));
		end
	elseif newTime < self.huntingUtil.huntTime[1] then
		OperateAlert.show(LanUtil.getValue(123732));
	else
		OperateAlert.show(LanUtil.getValue(123727));
	end
end

function Lua_FactionHuntingWindow:onHelp()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(123712));
end

function Lua_FactionHuntingWindow:dispose()
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end
    self:superCall("dispose");
end


function Lua_FactionHuntingWindow:showRedDot(val)--红点显示
	if val == true then
		if self._redDotIcon == nil then
			self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian",435,-250, 0, 0);
			self._redDotIcon:setDepth(7);
			self._redDotIcon.name = "redDotIcon1";
		end
		self._redDotIcon:setEnable(true);
	else
		if self._redDotIcon ~= nil then
			self._redDotIcon:setEnable(false);
		end
	end
end

function Lua_FactionHuntingWindow:showRedDotTow(val)--红点显示
	if val == true then
		if self.redDotIcon == nil then
			self.redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian",-247,-250, 0, 0);
			self.redDotIcon:setDepth(7);
			self.redDotIcon.name = "redDotIcon2";
		end
		self.redDotIcon:setEnable(true);
	else
		if self.redDotIcon ~= nil then
			self.redDotIcon:setEnable(false);
		end
	end
end
